% Section 2.3.2, Program D : Differentiation Routines
% Author Chan Vinh VONG <chanvinh.vong@gmail.com>
% Draft Version 2012 April 14th
% Refined       2012 April 19th
%
%                 >|<-----OCTA----->|<
%                  +----------------+ 
%                  | RLINK/63 RTAG/1| BA+0
%                  +----------------+
%                  | LLINK/63 LTAG/1| BA+8
%                  +----------------+
%                  | INFO/60 TYPE/4 | BA+16
%                  +----------------+
%
% Remarks:
% - INFO and TYPE are stored in the same octa, resp. w/ 60 and 4 bits
%

% Global Variables:
%     :Y tree head

        PREFIX DIFF:

dRLINK      IS 8*0
dLLINK      IS 8*1
dINFOTYPE   IS 8*2
       
P       IS $0
P1      IS $1
P2      IS $2
Q1      IS $3
Q       IS $4
info    IS $5
type    IS $6
warp    IS $7
ret     IS $8
t       IS $9

:DIFF   LDOU  P1,:Y,dLLINK  % D1. Initialize
1H      SET   P,P1
        LDOU  P1,P,dLLINK
        BNZ   P1,1B          % Y$ is the leftmost node

        % Coroutine Test
        % GO :a,:b,0
        
D2      LDOU  P1,P,dLLINK
        BZ    P1,2F
        LDOU  Q1,P1,dRLINK
2H      LDOU  type,P,dINFOTYPE
        AND   type,type,#F
        INCL  type,1
switch  GREG  @
        STBU  type,switch,7
        JMP   @+4
        JMP   CONST
        JMP   VAR
        JMP   LN
        JMP   NEG
        JMP   ADD
        
D3      CMP   t,type,4
        BNP   t,D4
        STOU  P2,P1,dRLINK
        
D4      SET   P2,P
        LDOU  P,P,dRLINK
        BOD   P,4F          % it was a right thread hence we got P$
Scan    LDOU  t,P,dLLINK   % else hard link thus get leftmost node
        BZ    t,4F
        SET   P,t
        JMP   Scan    
4H      LDOU  t,P2,dRLINK
        BOD   t,D5
        STOU  Q,P2,dRLINK
        
D5      SRU   t,t,1
        SLU   t,t,1         % reset thread flag
        CMP   t,t,:Y
        BNZ   t,D2
        STOU  Q,:DY,dLLINK
        XOR   t,:DY,#1
        STOU  t,Q,dRLINK
        
        POP 0,0

XValue  IS #58

N_CONST0 GREG #0       % 0
N_CONST1 GREG #10      % 1
N_VARX   GREG #581     % "X"
N_VARY   GREG #591     % "Y"
N_LN     GREG #4C4E2   % "LN"
N_NEG    GREG #4E45473 % "NEG"
N_PLUS   GREG #2B4     % "+"
N_MINUS  GREG #2D5     % "-"
N_TIMES  GREG #2A6     % "*"
N_DIV    GREG #2F7     % "/"
N_PWR    GREG #5E8     % "^"

CONST   JMP 1F
VAR     LDOU  info,P,dINFOTYPE
        SRU   info,info,4
        CMP   t,info,XValue
        BNZ   t,1F
        SET   t+2,N_CONST1
        JMP   2F
1H      SET   t+2,N_CONST0
2H      GET   warp,:rJ
        PUSHJ t+1,:TREE0
        PUT   :rJ,warp
        SET   Q,t+1
        JMP   D3

LN      LDOU  info,Q,dINFOTYPE
        BZ    info,D3
        GET   warp,:rJ
        SET   t+2,P1
        PUSHJ t+1,:COPYRTBT
        SET   t+4,t+1
        SET   t+3,Q
        SET   t+2,N_DIV
        PUSHJ t+1,:TREE2
        PUT   :rJ,warp
        SET   Q,t+1
        JMP D3

NEG     LDOU  info,Q,dINFOTYPE
        BZ    info,3F   % NEG 0 = 0
        SET   t+3,Q
        SET   t+2,N_NEG
        GET   warp,:rJ
        PUSHJ t+1,:TREE1
        PUT   :rJ,warp
        SET   Q,t+1
3H      JMP   D3
        
ADD     LDOU  info,Q1,dINFOTYPE
        BZ    info,D3           % dU = 0, dY = dV
        LDOU  info,Q,dINFOTYPE
        BNZ   info,4F
        SET   Q,Q1              % dU != 0 and dV = 0
        JMP   D3
4H      GET   warp,:rJ          % dU != 0 and dV != 0
        SET   t+4,Q
        SET   t+3,Q1
        SET   t+2,N_PLUS
        PUSHJ t+1,:TREE2
        SET   Q,t+1
        PUT   :rJ,warp
        JMP   D3
        
        PREFIX :
