[[COMMENT Test Plan: see attached diagrams]]

[[SET DRIVER

dRLINK  IS 8*0
dLLINK  IS 8*1

PAGE    IS 8192
        LOC Data_Segment+PAGE*0  % #2000..0000
BASE    GREG @
        [[Y]]
AVAIL   GREG @
BASEDY  GREG 0  % DY is built after Y in the same stack

        LOC Data_Segment+PAGE*1  % #2000..2000
        
Y       GREG @   % List head for Y
        OCTA @   % ..2000 RLINK
        OCTA 0   % ..2008 LLINK
        OCTA 0   % ..2010 INFO/TYPE
        
DY      GREG @   % List head for DY
        OCTA @   % ..2018 RLINK
        OCTA 0   % ..2020 LLINK
        OCTA 0   % ..2028 INFO/TYPE

        LOC Data_Segment+PAGE*2  % #2000..4000
ExpDYNodes GREG @
        [[ExpDYNodes]]

        LOC Data_Segment+PAGE*3  % #2000..6000
ExpDY   GREG @
        [[ExpDY]]

        [[INCLUDE msg.mms]]
        
        LOC #100
        GREG @
        
        [[INCLUDE octa2ascii.mms]]
        [[INCLUDE compare.mms]]
        
        [[INCLUDE S232PD-TREE.mms]]
        [[INCLUDE S232PD-COPYRTBT.mms]]
        [[INCLUDE S232PD-DIFF.mms]]
        
        GREG @
        
temp    IS $0
Main    IS @

        % Avoid synonyms
        SET BASEDY,AVAIL

        % Wire Y head list to the tree
        [[WireY]]
        
        PUSHJ $0,DIFF
        
        % Check Stack
        SET   $1,AVAIL
        SETH  $2,#2000
        INCL  $2,[[ExpAVAIL]]
        PUSHJ $0,EXP_OCTA
        
        % Check list head DY
        SET   $1,DY
        SET   $2,ExpDY
        SET   $3,3
        PUSHJ $0,COMPARE
        
        % Check tree DY
        SET   $1,BASEDY
        SET   $2,ExpDYNodes
        SET   $3,[[Octas]]
        PUSHJ $0,COMPARE
        
        SET   $255,0
        TRAP
]]

[[COMMENT ===========================================================]]

[[TEST 10]]
[[COMMENT Topology: very simple. Y = 42. Can't do simpler.]]
[[SET Y
        % P = (42) @ #2000..00
        OCTA #2000000000002001 % RT to Y head
        OCTA 0
        OCTA #2A0
]]
[[SET WireY
        SETH temp,#2000
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0030]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000018
        OCTA #0
]]
[[SET ExpDYNodes
        % dP = (0) @ #2000..18
        OCTA #2000000000002019  % RT-LINK to DY head
        OCTA #0
        OCTA #0
]]
[[SET Octas 3]]
[[DRIVER]]
[[END 10]]

[[COMMENT ===========================================================]]

[[TEST 100]]
[[COMMENT Topology: Y = Z, DY = 0]]
[[SET Y
        % P = (Z) @ #2000..00
        OCTA #2000000000002001 % RT to Y head
        OCTA 0
        OCTA #5A1
]]
[[SET WireY
        SETH temp,#2000
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0030]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000018
        OCTA #0
]]
[[SET ExpDYNodes
        % dP = (0) @ #2000..18
        OCTA #2000000000002019  % RT-LINK to DY head
        OCTA #0
        OCTA #0
]]
[[SET Octas 3]]
[[DRIVER]]
[[END 100]]

[[COMMENT ===========================================================]]

[[TEST 110]]
[[COMMENT Topology: Y = X, DY = 1]]
[[SET Y
        % P = (X) @ #2000..00
        OCTA #2000000000002001 % RT to Y head
        OCTA 0
        OCTA #581
]]
[[SET WireY
        SETH temp,#2000
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0030]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000018
        OCTA #0
]]
[[SET ExpDYNodes
        % dP = (1) @ #2000..18
        OCTA #2000000000002019  % RT-LINK to DY head
        OCTA #0
        OCTA #10
]]
[[SET Octas 3]]
[[DRIVER]]
[[END 110]]

[[COMMENT ===========================================================]]

[[TEST 200]]
[[COMMENT Topology: Y = LN 42, DY = 0]]
[[SET Y
        % U = (42) @ #2000..00
        OCTA #2000000000000019 % RT to LN
        OCTA 0
        OCTA #2A0
        
        % P = (LN) @ #2000..18
        OCTA #2000000000002001 % RT to Y head
        OCTA #2000000000000000 % link to X
        OCTA #4C4E2
]]
[[SET WireY
        SETH temp,#2000
        INCL temp,#0018
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0048]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000030
        OCTA #0
]]
[[SET ExpDYNodes
        % dP = (0) @ #2000..0030
        OCTA #2000000000002019  % RT to DY head
        OCTA #0
        OCTA #0
]]
[[SET Octas 3]]
[[DRIVER]]
[[END 200]]


[[COMMENT ===========================================================]]

[[TEST 210]]
[[COMMENT Topology: Y = LN X, DY = 1 / X]]
[[SET Y
        % U = (X) @ #2000..00
        OCTA #2000000000000019 % RT to LN
        OCTA 0
        OCTA #581
        
        % P = (LN) @ #2000..18
        OCTA #2000000000002001 % RT to Y head
        OCTA #2000000000000000 % link to X
        OCTA #4C4E2
]]
[[SET WireY
        SETH temp,#2000
        INCL temp,#0018
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0078]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000060
        OCTA #0
]]
[[SET ExpDYNodes
        % dU = (1) @ #2000..30
        OCTA #2000000000000048  % R-LINK to (X)
        OCTA #0
        OCTA #10
        
        % copy of U = (X) @ #2000..48
        OCTA #2000000000000061  % RT-LINK to (/)
        OCTA #0
        OCTA #581
        
        % dP = (/) @ #2000..60
        OCTA #2000000000002019  % RT to DY head
        OCTA #2000000000000030  % LLINK to (1)
        OCTA #2F7
]]
[[SET Octas 9]]
[[DRIVER]]
[[END 210]]

[[COMMENT ===========================================================]]

[[TEST 300]]
[[COMMENT Topology: Y = NEG 42, DY = 0]]
[[SET Y
        % U = (X) @ #2000..00
        OCTA #2000000000000019 % RT to NEG
        OCTA 0
        OCTA #2A0
        
        % P = (NEG) @ #2000..18
        OCTA #2000000000002001 % RT to Y head
        OCTA #2000000000000000 % link to X
        OCTA #4E45473
]]
[[SET WireY
        SETH temp,#2000
        INCL temp,#0018
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0048]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000030
        OCTA #0
]]
[[SET ExpDYNodes
        % dP = (0) @ #2000..30
        OCTA #2000000000002019  % RT to DY head
        OCTA #0
        OCTA #0
]]
[[SET Octas 3]]
[[DRIVER]]
[[END 300]]

[[COMMENT ===========================================================]]

[[TEST 310]]
[[COMMENT Topology: Y = NEG X, DY = NEG 1]]
[[SET Y
        % U = (X) @ #2000..00
        OCTA #2000000000000019 % RT to NEG
        OCTA 0
        OCTA #581
        
        % P = (NEG) @ #2000..18
        OCTA #2000000000002001 % RT to Y head
        OCTA #2000000000000000 % link to X
        OCTA #4E45473
]]
[[SET WireY
        SETH temp,#2000
        INCL temp,#0018
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0060]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000048
        OCTA #0
]]
[[SET ExpDYNodes
        % dU = (1) @ #2000..30
        OCTA #2000000000000049  % RT to NEG
        OCTA #0
        OCTA #10
        
        % dP = (NEG) @ #2000..48
        OCTA #2000000000002019  % RT-LINK to list head DY
        OCTA #2000000000000030  % link to 1
        OCTA #4E45473
]]
[[SET Octas 6]]
[[DRIVER]]
[[END 310]]

[[COMMENT ===========================================================]]

[[TEST 400]]
[[COMMENT Topology: Y = 42 + X, DY = 1]]
[[SET Y
        % V = (X) @ #2000..00
        OCTA #2000000000000031 % RTLINK to P
        OCTA 0
        OCTA #581
        
        % U = (42) @ #2000..18
        OCTA #2000000000000000 % RLINK to V
        OCTA 0
        OCTA #2A0
        
        % P = ("+") @ #2000..30
        OCTA #2000000000002001 % RTLINK to Y head
        OCTA #2000000000000018 % LLINK to U
        OCTA #2B4
]]
[[SET WireY
        SETH temp,#2000
        INCL temp,#0030
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0078]]
[[COMMENT there is no AVAIL collection yet]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000060
        OCTA #0
]]
[[SET ExpDYNodes
        % dU = (0) garbaged
        OCTA #0
        OCTA #0
        OCTA #0

        % dV = (1)
        OCTA #2000000000002019 % RTLINK to list head DY
        OCTA #0
        OCTA #10
]]
[[SET Octas 6]]
[[DRIVER]]
[[END 400]]

[[COMMENT ===========================================================]]

[[TEST 410]]
[[COMMENT Topology: Y = X + 42, DY = 1]]
[[SET Y
        % V = (42) @ #2000..00
        OCTA #2000000000000031 % RTLINK to P
        OCTA 0
        OCTA #2A0
        
        % U = (X) @ #2000..18
        OCTA #2000000000000000 % RLINK to V
        OCTA 0
        OCTA #581
        
        % P = ("+") @ #2000..30
        OCTA #2000000000002001 % RTLINK to Y head
        OCTA #2000000000000018 % LLINK to U
        OCTA #2B4
]]
[[SET WireY
        SETH temp,#2000
        INCL temp,#0030
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0078]]
[[COMMENT there is no AVAIL collection yet]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000048
        OCTA #0
]]
[[SET ExpDYNodes
        % dU = (1)
        OCTA #2000000000002019 % RTLINK to list head DY
        OCTA #0
        OCTA #10

        % dV = (0) garbaged 
        OCTA #0
        OCTA #0
        OCTA #0
]]
[[SET Octas 6]]
[[DRIVER]]
[[END 410]]

[[COMMENT ===========================================================]]

[[TEST 420]]
[[COMMENT Topology: Y = 10 + 42, DY = 0]]
[[SET Y
        % V = (42) @ #2000..00
        OCTA #2000000000000031 % RTLINK to P
        OCTA 0
        OCTA #2A0
        
        % U = (10) @ #2000..18
        OCTA #2000000000000000 % RLINK to V
        OCTA 0
        OCTA #A0
        
        % P = ("+") @ #2000..30
        OCTA #2000000000002001 % RTLINK to Y head
        OCTA #2000000000000018 % LLINK to U
        OCTA #2B4
]]
[[SET WireY
        SETH temp,#2000
        INCL temp,#0030
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0078]]
[[COMMENT there is no AVAIL collection yet]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000060
        OCTA #0
]]
[[SET ExpDYNodes
        % dU = (0) garbaged
        OCTA #0
        OCTA #0
        OCTA #0

        % dV = (0)
        OCTA #2000000000002019 % RTLINK to list head DY
        OCTA #0
        OCTA #0
]]
[[SET Octas 6]]
[[DRIVER]]
[[END 420]]

[[COMMENT ===========================================================]]

[[TEST 430]]
[[COMMENT Topology: Y = X + X, DY = 1 + 1]]
[[SET Y
        % V = (X) @ #2000..00
        OCTA #2000000000000031 % RTLINK to P
        OCTA 0
        OCTA #581
        
        % U = (X) @ #2000..18
        OCTA #2000000000000000 % RLINK to V
        OCTA 0
        OCTA #581
        
        % P = ("+") @ #2000..30
        OCTA #2000000000002001 % RTLINK to Y head
        OCTA #2000000000000018 % LLINK to U
        OCTA #2B4
]]
[[SET WireY
        SETH temp,#2000
        INCL temp,#0030
        STOU temp,Y,dLLINK
]]
[[SET ExpAVAIL #0090]]
[[SET ExpDY
        OCTA #2000000000002018
        OCTA #2000000000000078
        OCTA #0
]]
[[SET ExpDYNodes
        % dU = (1) @ #2000..48
        OCTA #2000000000000060
        OCTA #0
        OCTA #10

        % dV = (1) @ #2000..60
        OCTA #2000000000000079 % RTLINK to dY
        OCTA #0
        OCTA #10
        
        % dY = ("+") @ #2000..78
        OCTA #2000000000002019 % RTLINK to list head DY
        OCTA #2000000000000048
        OCTA #2B4
]]
[[SET Octas 9]]
[[DRIVER]]
[[END 430]]
