[[COMMENT Test Plan:

Test Return Value:
The tests check that after a sequence of calls, returned Q is correct.
TEST 1 : TREE0
TEST 2 : TREE0 then TREE1
TEST 3 : TREE0 then TREE1 then TREE2

Test Entry Conditions:
The tests check that even with "noise" parameters, TREEx works as
expected.
TEST 11 : TREE0(x,U,V) w/ U and V not null
TEST 12 : TREE1(x,U,V) w/ V not null

Test Exit Conditions:
The tests check that the pool as been modified as expected.
TEST 21 : two single nodes
TEST 22 : two linked nodes (left link)
TEST 23 : three linked nodes (left then right links)

Variables Page Remarks
        -    0 Pool
    SETUP    - calls to TREEx
   CHKRET    - check return value
 CHKAVAIL    - check value of AVAIL
  CHKPOOL    - compare current and expected pools
  EXPPOOL    1 expected pools

]]

[[SET DRIVER

% placeholder for return values (decouples between checks)
retval  GREG 0

PAGE    IS 8192
        LOC Data_Segment+PAGE*0
BASE    GREG @
AVAIL   GREG 0

        LOC Data_Segment+PAGE*1
        GREG @
EXPPOOL [[EXPPOOL]]

        [[INCLUDE msg.mms]]
        
        LOC #100
        GREG @
        
        [[INCLUDE octa2ascii.mms]]
        [[INCLUDE compare.mms]]
        
        [[INCLUDE S232PD-TREE.mms]]
        
Main    IS @

        % reset stack
        SET AVAIL,BASE

        [[SETUP]]
        
        [[CHKRET]]
        
        [[CHKAVAIL]]
        
        [[CHKPOOL]]

        SET $255,0
        TRAP
]]

[[COMMENT ===========================================================]]

[[TEST 1]]
[[SET SETUP % Run and check return value
        SET   $1,1
        PUSHJ $0,TREE0
        SET   retval,$0
]]
[[SET CHKRET
        SET   $1,retval
        SETH  $2,#2000
        INCL  $2,#0000
        PUSHJ $0,EXP_OCTA
]]
[[SET CHKAVAIL % irrelevant in this test]]
[[SET EXPPOOL OCTA 0 % irrelevant in this test]]
]]
[[SET CHKPOOL % irrelevant in this test]]
[[DRIVER]]
[[END 1]]

[[COMMENT ===========================================================]]

[[TEST 2]]
[[SET SETUP % Run and check return value
        SET   $1,1
        PUSHJ $0,TREE0
        SET   $1,2
        SET   $2,$0
        PUSHJ $0,TREE1        
        SET   retval,$0
]]
[[SET CHKRET
        SET   $1,retval
        SETH  $2,#2000
        INCL  $2,#0018
        PUSHJ $0,EXP_OCTA
]]
[[SET CHKAVAIL % irrelevant in this test]]
[[SET EXPPOOL OCTA 0 % irrelevant in this test]]
[[SET CHKPOOL % irrelevant in this test]]
[[DRIVER]]
[[END 2]]


[[COMMENT ===========================================================]]

[[TEST 3]]
[[SET SETUP % Run and check return value
        SET   $3,1
        PUSHJ $2,TREE0
        SET   $4,2
        PUSHJ $3,TREE0
        SET   $1,3
        PUSHJ $0,TREE2
        SET   retval,$0
]]
[[SET CHKRET
        SET   $1,retval
        SETH  $2,#2000
        INCL  $2,#0030
        PUSHJ $0,EXP_OCTA
]]
[[SET CHKAVAIL % irrelevant in this test]]
[[SET EXPPOOL OCTA 0 % irrelevant in this test]]
[[SET CHKPOOL % irrelevant in this test]]
[[DRIVER]]
[[END 3]]

[[COMMENT ===========================================================]]

[[TEST 11]]
[[SET SETUP
        SET $3,11 % dirty arg
        SET $2,42 % dirty arg
        SET $1,1
        PUSHJ $0,TREE0
]]
[[SET CHKRET ]]
[[SET CHKAVAIL ]]
[[SET EXPPOOL OCTA 0,0,1
]]
[[SET CHKPOOL % Check pool
        SET $1,BASE
        LDA $2,EXPPOOL
        SET $3,3
        PUSHJ $0,COMPARE
]]
[[DRIVER]]
[[END 11]]

[[COMMENT ===========================================================]]

[[TEST 12]]
[[SET SETUP
        SET $1,1
        PUSHJ $0,TREE0
        SET $1,2
        SET $2,$0
        SET $3,42 % dirty arg
        PUSHJ $0,TREE1
]]
[[SET CHKRET ]]
[[SET CHKAVAIL ]]
[[SET EXPPOOL OCTA #2000000000000019
              OCTA 0
              OCTA 1
              OCTA 0
              OCTA #2000000000000000
              OCTA 2
]]
[[SET CHKPOOL % Check pool
        SET $1,BASE
        LDA $2,EXPPOOL
        SET $3,6
        PUSHJ $0,COMPARE
]]
[[DRIVER]]
[[END 12]]

[[COMMENT ===========================================================]]

[[TEST 21]]
[[COMMENT Topology: 2 leafs

            (W1)     (W2)

]]
[[SET SETUP % Build one node holding "1"
        SET $1,1
        PUSHJ $0,TREE0

        % Build one node holding "2"
        SET $1,2
        PUSHJ $0,TREE0
]]
[[SET CHKRET ]]
[[SET CHKAVAIL
        SET   $1,AVAIL
        SETH  $2,#2000
        INCL  $2,#0030
        PUSHJ $0,EXP_OCTA
]]
[[SET EXPPOOL OCTA 0,0,1 % (W1)
              OCTA 0,0,2 % (W2)
]]
[[SET CHKPOOL % Check pool
        SET $1,BASE
        LDA $2,EXPPOOL
        SET $3,6
        PUSHJ $0,COMPARE
]]
[[DRIVER]]
[[END 21]]

[[COMMENT ===========================================================]]

[[TEST 22]]
[[COMMENT Topology:

                    (W)
                    /  \ right-thread
                  (U)--/

]]
[[SET SETUP % Build node
        SET $1,1
        PUSHJ $0,TREE0
        
        % Build node and link
        SET $1,2
        SET $2,$0   % U <- W
        PUSHJ $0,TREE1
]]
[[SET CHKRET ]]
[[SET CHKAVAIL
        SET   $1,AVAIL
        SETH  $2,#2000
        INCL  $2,#0030
        PUSHJ $0,EXP_OCTA
]]
[[SET EXPPOOL OCTA #2000000000000019 % (U)
              OCTA 0
              OCTA 1
              OCTA 0                 % (W)
              OCTA #2000000000000000
              OCTA 2
]]
[[SET CHKPOOL % Check pool
        SET $1,BASE
        LDA $2,EXPPOOL
        SET $3,6
        PUSHJ $0,COMPARE
]]
[[DRIVER]]
[[END 22]]

[[COMMENT ===========================================================]]

[[TEST 23]]
[[COMMENT Topology:

                     (W)
                     /  \
                   (U)   | right-thread
                     \   |
                     (V)-|
]]
[[SET SETUP % Build node
        SET $3,1
        PUSHJ $2,TREE0
        % $2 will be U
        
        SET $4,2
        PUSHJ $3,TREE0
        % $3 will be V
        
        SET $1,3
        PUSHJ $0,TREE2
]]
[[SET CHKRET ]]
[[SET CHKAVAIL
        SET   $1,AVAIL
        SETH  $2,#2000
        INCL  $2,#0048
        PUSHJ $0,EXP_OCTA
]]
[[SET EXPPOOL OCTA #2000000000000018 % (U)
              OCTA 0
              OCTA 1
              OCTA #2000000000000031 % (V)
              OCTA 0
              OCTA 2
              OCTA 0                 % (W)
              OCTA #2000000000000000
              OCTA 3
]]
[[SET CHKPOOL % Check pool
        SET $1,BASE
        LDA $2,EXPPOOL
        SET $3,9
        PUSHJ $0,COMPARE
]]
[[DRIVER]]
[[END 23]]

[[COMMENT ===========================================================]]
